
class Signal; class Zone; class Aiguille; class Itineraire;

/////////////////////////////////////////////////////////////////////////////

const boolean TCO=true; // avec (true) ou sans tco (false)

enum {COULEUR_GRISE,COULEUR_ROUGE,COULEUR_BLANCHE,COULEUR_JAUNE,COULEUR_VERTE,COULEUR_ROSE}; // couleurs

#include "TCO.h"

#include "AiguilleEtZone.h"
#include "Signal.h"
#include "Signaux.h"
#include "SignalBAL.h"
#include "SignauxBAL.h"
#include "Itineraire.h"
#include "Fonctions.h"

/////////////////////////////////////////////////////////////////////////////

// les zones reelles, a ecrire par l'utilisateur

class Z0 : public Zone {
public:
  Z0(int n,Signal* sp,Signal* si):Zone(n,sp,si) {no=n;}// constructeur mini
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z1 : public Zone { 
public:
  Z1(int n,Signal* sp,Signal* si):Zone(n,sp,si) {}// constructeur mini
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z2 : public Zone { 
public:
  Z2(int n,Signal* sp,Signal* si):Zone(n,sp,si) {}// constructeur mini
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z3 : public Zone { 
public:
  Z3(int n,Signal* sp,Signal* si):Zone(n,sp,si) {}// constructeur mini
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z4 : public Zone { 
public:
  Z4(int n,Signal* sp,Signal* si):Zone(n,sp,si) {}// constructeur mini
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z5 : public Zone { 
public:
  Z5(int n,Signal* sp,Signal* si):Zone(n,sp,si) {}// constructeur mini
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

/////////////////////////////////////////////////////////////////////////////
// les signaux reels, a ecrire par l'utilisateur

class S1:public SemaphoreBALRalentissement { 
public:
  S1(int n):SemaphoreBALRalentissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
  virtual boolean cantonOccupe();
};

class S2:public SemaphoreBALRalentissement { 
public:
  S2(int n):SemaphoreBALRalentissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
  virtual boolean cantonOccupe();
};

class C3:public CarreAvertissement {
public:
  C3(int n):CarreAvertissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
};

class C4:public CarreAvertissement {
public:
  C4(int n):CarreAvertissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
};

class C5:public CarreAvertissement {
public:
  C5(int n):CarreAvertissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
};

class C6:public CarreAvertissement {
public:
  C6(int n):CarreAvertissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
};

class C1:public CarreAvertissementRappelRalentissement {
public:
  C1(int n):CarreAvertissementRappelRalentissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
  virtual boolean ralentissement30();
};

class C2:public CarreAvertissementRappelRalentissement {
public:
  C2(int n):CarreAvertissementRappelRalentissement(n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
  virtual boolean ralentissement30();
};

/////////////////////////////////////////////////////////////////////////////
// l'autorisation

class Aut:public Autorisation {
public:
  Aut() {} // constructeur vide
  virtual boolean aucunTrain();
};

//  //  // //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //
// les itineraires reels, a ecrire par l'utilisateur

class XA:public Itineraire { 
public:
  XA(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

class XB:public Itineraire { 
public:
  XB(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

class AX:public Itineraire { 
public:
  AX(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

class BX:public Itineraire { 
public:
  BX(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

class YA:public Itineraire { 
public:
  YA(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

class YB:public Itineraire { 
public:
  YB(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

class AY:public Itineraire { 
public:
  AY(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

class BY:public Itineraire { 
public:
  BY(int n):Itineraire(n) {}
  virtual boolean formable();
  virtual void former();
  virtual boolean deformable();
  virtual void deformer();
  virtual void tracer(boolean b);
};

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// declarations, a ecrire par l'utilisateur

SignalBAL* s1=new S1(0); SignalBAL* s2=new S2(1);
Signal* c1=new C1(2); Signal* c2=new C2(3); 
Signal* c3=new C3(4); Signal* c4=new C4(5); 
Signal* c5=new C5(6); Signal* c6=new C6(7); 

#define MaxSignal 8

Signal* tableSignaux[MaxSignal] {s1,s2, c1,c2, c3,c4, c5,c6}; // la table des signaux

Zone* z0=new Z0(0,c4,c3);
Zone* z1=new Z1(1,c6,c5); 
Zone* z2=new Z2(2,NULL,NULL);
Zone* z3=new Z3(3,s2,c1);
Zone* z4=new Z4(4,c2,s2);
Zone* z5=new Z5(5,NULL,NULL);

#define MaxZone  6

Zone* tableZones[MaxZone] {z0, z1, z2, z3, z4, z5}; // la table des zones pour la retrosignalisation

Aiguille* a0=new Aiguille(0); //aiguille a0 dans zone z2
Aiguille* a1=new Aiguille(1); //aiguille a1 dans zone z5

Autorisation* aut=new Aut;

Itineraire *xa=new XA(0),*xb=new XB(1),*ax=new AX(2),*bx=new BX(3);
Itineraire *ya=new YA(4),*yb=new YB(5),*ay=new AY(6),*by=new BY(7);

#define MaxItineraire 8

Itineraire* tableItineraires[MaxItineraire] {xa,xb,ax,bx,ya,yb,ay,by}; // la table des itineraires pour tco

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// les methodes des zones, a ecrire par l'utilisateur

Zone* Z0::suivantePaire() { return selonAiguille(a0,z2,NULL); }
Zone* Z0::suivanteImpaire() { return selonAiguille(a1,z5,NULL); }

Zone* Z1::suivantePaire() { return selonAiguille(a0,NULL,z2); }
Zone* Z1::suivanteImpaire() { return selonAiguille(a1,NULL,z5); }

void Z2::actions() { aubiner(c1,c4,c6); }
void Z2::desactions() { detruire(xa,xb,ax,bx); }
Zone* Z2::suivantePaire() { return z3; }
Zone* Z2::suivanteImpaire() { return selonAiguille(a0,z0,z1); } 

void Z3::actions() { if (z4->occupee()) aubiner(s1); }
void Z3::desactions() { s1->desaubiner(); }
Zone* Z3::suivantePaire() { return z4; }
Zone* Z3::suivanteImpaire() { return z2; }

void Z4::actions() { if (z3->occupee()) aubiner(s2); }
void Z4::desactions() { s2->desaubiner(); }
Zone* Z4::suivantePaire() { return z5; }
Zone* Z4::suivanteImpaire() { return z3; }

void Z5::actions() { aubiner(c2,c3,c5); }
void Z5::desactions() { detruire(ya,yb,ay,by); }
Zone* Z5::suivantePaire() { return selonAiguille(a1,z0,z1); }
Zone* Z5::suivanteImpaire() { return z4; }

/////////////////////////////////////////////////////////////////////////////
// les methodes des signaux, a ecrire par l'utilisateur

Signal* S1::suivant() { return c1; }
Signal* S1::precedent() { return selonAiguille(a1,c3,c5); }
boolean S1::cantonOccupe() { return z3->occupee(); }

Signal* S2::suivant() { return c2; }
Signal* S2::precedent() { return selonAiguille(a0,c4,c6); }
boolean S2::cantonOccupe() { return z4->occupee(); }

Signal* C3::suivant() { return s1; }
Signal* C3::precedent() { return c1; }

Signal* C5::suivant() { return s1; }
Signal* C5::precedent() { return c1; }

Signal* C4::suivant() { return s2; }
Signal* C4::precedent() { return c2; }

Signal* C6::suivant() { return s2; }
Signal* C6::precedent() { return c2; }

Signal* C1::suivant() { return selonAiguille(a0,c3,c5); } 
Signal* C1::precedent() { return s1; }
boolean C1::ralentissement30() { return a0->deviee()?true:false; }
  
Signal* C2::suivant() { return selonAiguille(a1,c4,c6); } 
Signal* C2::precedent() { return s2; }
boolean C2::ralentissement30() { return a1->deviee()?true:false; }
   
/////////////////////////////////////////////////////////////////////////////
// methode de l'autorisation

boolean Aut::aucunTrain() { return libres(z3,z4); }

//  //  // //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //
// methodes des itineraires, a ecrire par l'utilisateur

boolean XA::formable() { return libres(xa,xb,ax,bx,ya) && libres(z2,z0); }
void XA::former() { a0->directer(); c1->ouvrir(); }
boolean XA::deformable() { return libres(z3,z2); }
void XA::deformer() { c1->fermer(); }
void XA::tracer(boolean b) { trace(b,z3,z2,z0); }

boolean XB::formable() { return libres(xa,xb,ax,bx,yb) && libres(z2,z1); }
void XB::former() { a0->devier(); c1->ouvrir(); }
boolean XB::deformable() { return libres(z3,z2); }
void XB::deformer() { c1->fermer(); }
void XB::tracer(boolean b) { trace(b,z3,z2,z1); }

boolean AX::formable() { return libres(xa,xb,ax,bx,ay,by) && libres(z2,z3/*,z4*/) && aut->prenable(SENS_PAIR); }
void AX::former() { a0->directer(); aut->prendre(SENS_PAIR); c4->ouvrir(); }
boolean AX::deformable() { return libres(z0,z2); }
void AX::deformer() { c4->fermer(); aut->rendre(); }
void AX::tracer(boolean b) { trace(b,z0,z2,z3); }

boolean BX::formable() { return libres(xa,xb,ax,bx,ay,by) && libres(z2,z3/*,z4*/)&& aut->prenable(SENS_PAIR); }
void BX::former() { a0->devier(); aut->prendre(SENS_PAIR); c6->ouvrir(); }
boolean BX::deformable() { return libres(z1,z2); }
void BX::deformer() { c6->fermer(); aut->rendre(); }
void BX::tracer(boolean b) { trace(b,z1,z2,z3); }


boolean YA::formable() { return libres(ya,yb,ay,by,xa) && libres(z5,z0); }
void YA::former() { a1->directer(); c2->ouvrir(); }
boolean YA::deformable() { return libres(z4,z5); }
void YA::deformer() { c2->fermer(); }
void YA::tracer(boolean b) { trace(b,z4,z5,z0); }

boolean YB::formable() { return libres(ya,yb,ay,by,xb) && libres(z5,z1); }
void YB::former() { a1->devier(); c2->ouvrir(); }
boolean YB::deformable() { return libres(z4,z5); }
void YB::deformer() { c2->fermer(); }
void YB::tracer(boolean b) { trace(b,z4,z5,z1); }

boolean AY::formable() { return libres(ya,yb,ay,by,ax,bx) && libres(z5,z4/*,z3*/) && aut->prenable(SENS_IMPAIR); }
void AY::former() { a1->directer(); aut->prendre(SENS_IMPAIR); c3->ouvrir(); }
boolean AY::deformable() { return libres(z0,z5); }
void AY::deformer() { c3->fermer(); aut->rendre(); }
void AY::tracer(boolean b) { trace(b,z0,z5,z4); }

boolean BY::formable() { return libres(ya,yb,ay,by,ax,bx) && libres(z5,z4/*,z3*/) && aut->prenable(SENS_IMPAIR); }
void BY::former() { a1->devier(); aut->prendre(SENS_IMPAIR); c5->ouvrir(); }
boolean BY::deformable() { return libres(z1,z5); }
void BY::deformer() { c5->fermer(); aut->rendre(); }
void BY::tracer(boolean b) { trace(b,z1,z5,z4); }

/////////////////////////////////////////////////////////////////////////////

void initialisation() { byte i; // (re)initialisation des aiguilles, des zones et des signaux
  a0->directer(); a1->directer();
  for (i=0; i<MaxSignal; i++)     tableSignaux[i]->init();
  for (i=0; i<MaxZone; i++)       tableZones[i]->init(); 
  aut->init();
  for (i=0; i<MaxItineraire; i++) tableItineraires[i]->init();
}

int freeRam () { int v; // calcul de la memoire libre
  extern int __heap_start, *__brkval;    
  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval); 
}

void setup() { 
  Serial.begin(9600); 
  if (!TCO) Serial.println(freeRam());
  initialisation(); // pas utile ???
}

void loop() { Itineraire* it; char code=0; 
  if (Serial.available()>=1) { // test si retrosignalisation ou commande
    code=Serial.read(); 
    if (!TCO) { Serial.println(); Serial.print(code); Serial.print(':'); Serial.print(' '); }
    if (code=='X') { // commande de reinitialisation
       initialisation(); 
    }
    if (code>='0' && code <='8') { // commande d'itineraire
      it=tableItineraires[code-'0'];
      if (it->enAttente()) it->effacer();   else // destruction
      if (it->libre())     it->formation(); else // essai de formation
      if (it->forme())     it->destruction();    // essai de destruction 
      if (!TCO && it->enAttente()) Serial.print('m'); 
    }
    if (code>='A' && code <='F') { // occupation zone (retrosignalisation)
       tableZones[code-'A']->occuper();
     }
    if (code>='a' && code <='f') { // liberation zone (retrosignalisation)
      tableZones[code-'a']->liberer();
    }
    code=0; return;
  }
  
  // test itineraires en attente
  for (int i=0; i<MaxItineraire; i++) {
    it=tableItineraires[i];
    if (it->enAttente()) {
      if (!TCO && it->formable()) { Serial.println('('); Serial.println(i); Serial.print(')'); Serial.print(':'); Serial.print(' '); }
      if (it->formable()) it->formation(); 
    }
  }
} // fin loop


