
// signaux manuels (sans BAL) les avertissements et les ralentissement sont geres automatiquement
// ces signaux peuvent etres mecaniques ou lumineux
// pour les signaux mecaniques a plusieurs cibles (2 ou 3) utiliser la classe idoine, 
//    ces signaux ont plusieurs moteurs, pour la manoeuvre utiliser 2 (ou 3) numeros consecutifs (no no+1 (no+2))

/////////////////////////////////////////////////////////////////////////////

class Avertissement:public Signal { // le suivant est forcement un carre ou un semaphore
public:
  Avertissement(int n):Signal(A,n) {} // constructeur mini   
  //Avertissement(char* nm,int t,int n):Signal(nm,t+AVERTISSEMENT,A,n) {} // constructeur maxi   
  
  virtual void aubiner(); // appelle par les methodes actions de zone
  virtual void majFeux(); // appele par le signal suivant           
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void Avertissement::aubiner() { // appelle par les methodes actions de zone
  if (ferme()) return; feux=A; manoeuvrer();
} 

void Avertissement::majFeux() { Signal* s; typeFeux f; // appele par le signal suivant           
  s=suivant(); if (s==NULL) { erreur(301); return; }
  if (s->ferme()) f=A; else f=Vl; 
  if (f!=feux) { feux=f; manoeuvrer(); } 
} 

/////////////////////////////////////////////////////////////////////////////

class AvertissementRalentissement:public Avertissement { // le suivant est forcement un carre
public:
  AvertissementRalentissement(int n):Avertissement(n) {} // constructeur mini
  //AvertissementRalentissement(char* nm,int t,int n):Avertissement(nm,t+AVERTISSEMENT+RALENTISSEMENT,n) {} // constructeur maxi
  
  virtual void majFeux();
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void AvertissementRalentissement::majFeux() { Signal* s; typeFeux f; // appele par le signal suivant           
  s=suivant(); if (s==NULL) { erreur(301); return; }
  if (s->ferme()) f=A; else
  if (s->ralentissement60()) f=Rc; else
  if (s->ralentissement30()) f=R; 
  else                       f=Vl;  
  if (f!=feux) { feux=f; manoeuvrer(); } 
} 
  
/////////////////////////////////////////////////////////////////////////////

class Carre:public Signal {
public:
  Carre(int n):Signal(C,n) {} // constructeur mini
  //Carre(char* nm,int t,int n):Signal(nm,t+CARRE,C,n) {} // constructeur maxi
  
  virtual void ouvrir(); 
  virtual void fermer(); 
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void Carre::ouvrir() { if (ouvert()) return; feux=Vl; manoeuvreEtMajFeux(); } 
void Carre::fermer() { if (ferme())  return; feux=C;  manoeuvreEtMajFeux(); } 
  
/////////////////////////////////////////////////////////////////////////////

class CarreRappelRalentissement:public Carre {
public:
  CarreRappelRalentissement(int n):Carre(n) {} // constructeur
  //CarreRappelRalentissement(char* nm,int t,int n):Carre(nm,t+CARRE+RAPPEL_RALENTISSEMENT,n) {} // constructeur

  virtual void ouvrir();  
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void CarreRappelRalentissement::ouvrir() { 
  if (ouvert()) return; 
  if (ralentissement60()) feux=RRc; else
  if (ralentissement30()) feux=RR; 
  else                    feux=Vl;
  manoeuvreEtMajFeux();  
} 

/////////////////////////////////////////////////////////////////////////////

class CarreAvertissement:public Carre { // avertissement pour le carre suivant
public:
  CarreAvertissement(int n):Carre(n) {} // constructeur mini
  //CarreAvertissement(char* nm,int t,int n):Carre(nm,t+CARRE+AVERTISSEMENT,n) {} // constructeur maxi

  virtual void ouvrir();
  virtual typeFeux calculFeux();
  virtual void majFeux(); // appele par le carre suivant           
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void CarreAvertissement::ouvrir() { if (ouvert()) return; feux=calculFeux(); manoeuvreEtMajFeux(); }
    
typeFeux CarreAvertissement::calculFeux() { Signal* s; 
  s=suivant(); if (s==NULL) { erreur(301); return E; }
  if (s->ferme()) return A; else return Vl;
}

void CarreAvertissement::majFeux() { typeFeux f; // appele par le carre suivant           
 if (ferme()) return;
 f=calculFeux(); if (f!=feux) { feux=f; manoeuvreEtMajFeux(); } 
} 
  
/////////////////////////////////////////////////////////////////////////////

class CarreAvertissementRappelRalentissement:public CarreAvertissement { // ralentissement pour le carre suivant
public:
  CarreAvertissementRappelRalentissement(int n):CarreAvertissement(n) {} // constructeur mini
  //CarreAvertissementRappelRalentissement(char* nm,int t,int n):CarreAvertissement(nm,t+CARRE+RALENTISSEMENT+RAPPEL_RALENTISSEMENT,n) {} // constructeur maxi
  
  virtual typeFeux calculFeux(); // feux a l'ouverture
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

typeFeux CarreAvertissementRappelRalentissement::calculFeux() { Signal* s; // feux a l'ouverture
  s=suivant(); if (s==NULL) { erreur(301); return E; }
  if (s->ralentissement60()) if (s->ferme()) return A+Rc; else return Rc; else
  if (s->ralentissement30()) if (s->ferme()) return A+R;  else return R; 
  else                       if (s->ferme()) return A;    else return Vl;
}

/////////////////////////////////////////////////////////////////////////////

