

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Point {
  float x,y;
  
  Point(float x,float y) { this.x=x; this.y=y; }
  public String toString() { return " ("+x+','+y+") "; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Forme { 
  PShape s,p;
  PMatrix matrix=new PMatrix2D();
  Point[] points=null;

  Forme() { // constructeur
    s=createShape(); 
    p=createShape(); // dans arcs ???
  }

  void dessiner(int x,int y,int n,int c) { 
    s.setFill(c); 
    translate(B,B); // bordure
    scale(n); // zoom
    s.applyMatrix(matrix);
    shape(s,x,y); // decalage ligne colonne
    s.resetMatrix();
    resetMatrix();
  }
  
  void rotation() { matrix.apply(0,-1,9, 1,0,0);  }
  //void rotation() { s.applyMatrix(0,-1,9, 1,0,0); p.applyMatrix(0,-1,9, 1,0,0); }
  void symetrie() { matrix.apply(-1,0,9, 0,1,0); }
  //void symetrie() { s.applyMatrix(-1,0,9, 0,1,0); p.applyMatrix(-1,0,9, 0,1,0); }
  
  int largeur() { return 1; }

  void points() {}

  float getQuadBezPt(float p0,float p1,float p2,float t) { // p1 angle
    return p0 * (1 - t) * (1 - t) + 2 * p1 * (1 - t) * t + p2 * t * t;
  }
  
  float getQuadX(float p0x,float p1x,float p2x,float t) { return getQuadBezPt(p0x,p1x,p2x,t); } // (x = f(t))
  float getQuadY(float p0y,float p1y,float p2y,float t) { return getQuadBezPt(p0y,p1y,p2y,t); } // (y = g(t))
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Droit extends Forme { 
  Droit() { // constructeur
    s.beginShape();
    s.vertex(0,3); s.vertex(9,3); s.vertex(9,6); s.vertex(0,6);
    s.endShape(CLOSE);

    p.beginShape();
    p.vertex(1.5F,4.5F); p.vertex(7.5F,4.5F); 
    p.endShape();
}
  
  void points() { PVector v0=null,v1=null,v2=null; float dx,dy;
    points=new Point[3]; // 3 points
    v0=p.getVertex(0); matrix.mult(v0,v0); 
    v2=p.getVertex(1); matrix.mult(v2,v2); 
    points[0]=new Point(v0.x,v0.y); 
    points[1]=new Point(4.5F,4.5F); 
    points[2]=new Point(v2.x,v2.y); 
    /*
    points=new Point[3]; 
    points[0]=new Point(1.5F,4.5F); points[1]=new Point(4.5F,4.5F); points[2]=new Point(7.5F,4.5F); 
    */
  }
}

class DroitN extends Droit { // grand droit   pas de rotation ni de symetrie !!!
  int n;
  DroitN(int n) { 
    this.n=n;
    s.beginShape();
    s.vertex(0,3); s.vertex(9*n,3); s.vertex(9*n,6); s.vertex(0,6);
    s.endShape(CLOSE);
  }

  int largeur() { return n; }

  void points() { 
    points=new Point[3*n]; 
    for (int i=0; i<n; i++) {
      points[3*i+0]=new Point((i*9)+1.5F,4.5F); 
      points[3*i+1]=new Point((i*9)+4.5F,4.5F); 
      points[3*i+2]=new Point((i*9)+7.5F,4.5F); 
    }
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Arc extends Forme { 
  Arc() { // constructeur
    s.beginShape();
    s.vertex(10,1); s.quadraticVertex(5,6, 0,6); s.vertex(0,3); s.quadraticVertex(4,3, 8,-1);
    s.endShape(CLOSE);

    p.beginShape();
    p.vertex(0,4.5F); p.quadraticVertex(4.5F,4.5F, 9,0); 
    p.endShape();
  }

  void points() { PVector v0=null,v1=null,v2=null; float dx,dy;
    points=new Point[3]; // 3 points
    v0=p.getVertex(0); matrix.mult(v0,v0); 
    v1=p.getVertex(1); matrix.mult(v1,v1); 
    v2=p.getVertex(2); matrix.mult(v2,v2); 
    dx=getQuadX(v0.x,v1.x,v2.x,0.15F);
    dy=getQuadY(v0.y,v1.y,v2.y,0.15F);
    points[0]=new Point(dx,dy); 
    dx=getQuadX(v0.x,v1.x,v2.x,0.45F);
    dy=getQuadY(v0.y,v1.y,v2.y,0.45F);
    points[1]=new Point(dx,dy); 
    dx=getQuadX(v0.x,v1.x,v2.x,0.80F);
    dy=getQuadY(v0.y,v1.y,v2.y,0.80F);
    points[2]=new Point(dx,dy); 
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class ArcN extends Forme { // grande courbe
  int n;
  
  ArcN(int n) { // constructeur
    this.n=n;
    s.beginShape();
    s.vertex(0,3); s.quadraticVertex(9*(n-1)+6,3, 9*(n-1)+6,9*(n-1)+9); s.vertex(9*(n-1)+3,9*(n-1)+9); s.quadraticVertex(9*(n-1)+3,6, 0,6);
    s.endShape(CLOSE);
    p.beginShape();
    p.vertex(0,4.5F); p.quadraticVertex(9*(n-1)+4.5,4.5F, 9*(n-1)+4.5,9*(n-1)+9); 
    p.endShape();
  }

  void dessiner(int x,int y,int n,int c) { 
    super.dessiner(x,y,n,c);
    if (grille) { color(0); point(B+(x+4.5F)*N,B+(y+4.5F)*N); } // point a l'origine de l'arc
  }

  void points() { PVector v0=null,v1=null,v2=null; float dx=0,dy=0; float pas; int i=0,cpt=0; float d=1.70F;
    v0=p.getVertex(0); v1=p.getVertex(1); v2=p.getVertex(2);  
    matrix.mult(v0,v0); matrix.mult(v1,v1); matrix.mult(v2,v2);  
    pas=1.0F/(n*3.3F);
    for (float t=pas; t<=1.0F; t+=pas+pas) cpt++; points=new Point[3*cpt]; 
    for (float t=pas; t<=1.0F; t+=pas+pas) { 
      dx=getQuadX(v0.x,v1.x,v2.x,t-pas/d);
      dy=getQuadY(v0.y,v1.y,v2.y,t-pas/d);
      points[i++]=new Point(dx,dy); 
      dx=getQuadX(v0.x,v1.x,v2.x,t);
      dy=getQuadY(v0.y,v1.y,v2.y,t);
      points[i++]=new Point(dx,dy); 
      dx=getQuadX(v0.x,v1.x,v2.x,t+pas/d);
      dy=getQuadY(v0.y,v1.y,v2.y,t+pas/d);
      points[i++]=new Point(dx,dy); 
    }
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Cible extends Forme { // cible pour les signaux
  Cible() { // constructeur
    s.beginShape();
    s.vertex(3.4F,3); s.vertex(3.4F,0.4f); s.vertex(6,0.4F); s.vertex(6,-1); s.vertex(9,-1); s.vertex(9,2); s.vertex(6,2); s.vertex(6,0.6F); s.vertex(3.6F,0.6F); s.vertex(3.6F,3); 
    s.endShape(CLOSE);
  }
}

class Feu extends Forme { // feu pour es signaux
  int c;
  Feu(int c) { this.c=c; // constructeur
    s.beginShape();
    s.vertex(7.5F,-0.5F); 
    s.quadraticVertex(8.5F,-0.5F, 8.5F,0.5F); s.quadraticVertex(8.5F,1.5F, 7.5F,1.5F); 
    s.quadraticVertex(6.4F,1.5F, 6.5F,0.5F);  s.quadraticVertex(6.5F,-0.5F, 7.5F,-0.5F);
    s.endShape(CLOSE);
  }
  
  void dessiner(int x,int y,int n,int c) { 
    super.dessiner(x,y,n,this.c);
  }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Lettre extends Forme { // lettre pour itineraire
  char lettre;
  
  Lettre(char c) { lettre=c; }
  void dessiner(int x,int y,int n,int c) { 
    textSize(9*N); fill(color(0)); // noir
    textAlign(CENTER,CENTER); textMode(SHAPE);
    text(lettre,B+(x+4.5F)*N,B+(y+4.5F)*N);   
  }
}

class Nom extends Forme { // nom zone, aiguille et signal
  String nom;
  
  Nom(String n) { nom=n; }
  
  void dessiner(int x,int y,int n,int c) { 
    if (!infos) return;
    textSize(2.5F*N); fill(color(0)); // noir   perturbe les lettres !!!!!!!!!!!!
    textAlign(CENTER,CENTER); textMode(SHAPE);
    text(nom,B+(x+4.5F)*N,B+(y+4.5F)*N);   
  }
}
/*
class Bouton extends Forme { // bouton pour itineraire
  String nom;
  boolean fond;
  int couleur=COULEUR_GRISE;
  
  Bouton(String n,boolean b) { nom=n; fond=b; }
  
  void dessiner(int x,int y,int n,int c) { // c ne sert pas
    textSize(4*N); //    perturbe les lettres !!!!!!!!!!!!
    textAlign(CENTER,CENTER); textMode(SHAPE);
    if (fond) fill(couleur); else fill(211,211,211); rect(B+x*N,B+y*N,9*N,9*N,3*N); 
    fill(color(0)); text(nom,B+(x+4.5F)*N,B+(y+4.5F)*N);  // noir
  }
}
*/
class Retrait extends Forme { // retrait pour separation des zones
  void dessiner(int x,int y,int n,int c) { 
    super.dessiner(x,y,n,COULEUR_FOND); // couleur fond
  }
}

class RetraitGauche extends Retrait {
  RetraitGauche() { 
    s.beginShape();
    s.vertex(0,3);
    s.vertex(0+R,3);
    s.vertex(0+R,6);
    s.vertex(0,6);
    s.endShape(CLOSE);
  }
}

class RetraitDroit extends Retrait {
  RetraitDroit() { 
    s.beginShape();
    s.vertex(9,3);
    s.vertex(9,6);
    s.vertex(9-R,6);
    s.vertex(9-R,3);
    s.endShape(CLOSE);
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////