
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Pave {
  Forme[] formes;
  Forme retrait; // mettre plusieurs
  int col,lin; // les cordonnees du pave
  int couleur=COULEUR_GRISE; // couleur de la derniere forme (gris)
  boolean sens;
  
  Pave() {} // constructeur vide
  Pave(boolean s,Forme... fs) { formes=fs; sens=s; } // constructeur
  
  void dessiner(int x,int y,int n) { int l=formes.length;
    for (int i=0; i<l; i++) {
      if (i==l-1) formes[i].dessiner(x*9,y*9,n,couleur);   // la derniere forme
      else        formes[i].dessiner(x*9,y*9,n,COULEUR_NOIRE); // les autres formes (noir)
    }
    if (retrait!=null) retrait.dessiner(x*9,y*9,n,COULEUR_FOND); // couleur du fond
  }
  Pave rotation() { for (Forme f : formes) f.rotation(); return this; }
  Pave symetrie() { for (Forme f : formes) f.symetrie(); return this; }
  
  Pave retraitGauche() { retrait=new RetraitGauche(); return this; }
  Pave retraitDroit()  { retrait=new RetraitDroit();  return this; }
  
  Pave rotation (int n) { for (int i=0; i<n; i++) rotation(); return this; }
  int largeur() { if (formes==null) return 1; return formes[formes.length-1].largeur(); }

  void manoeuvrer() {} // inversion de l'aiguille
  
  void colorer(int c) { couleur=c; } // couleur pave (derniere forme)
  
  void feu(int c) {} // feu du signal
  
  String nom() { return null; } // obtention nom de bouton
  int no() { return -1; } // n° bouton
  void couleur(int c,boolean b) {} // couleur fond de bouton (avec clignotement)
  boolean cli() { return false; } // clignotant ou pas
  
  Point[] getPoints() { return formes[formes.length-1].points; }
}

class PaveAiguille extends Pave {
  PaveAiguille(boolean s) { super(s,new Arc(),new Droit()); }

  void manoeuvrer() { Forme f; f=formes[0]; formes[0]=formes[1]; formes[1]=f; } // permutation
}

class PaveDroit extends Pave {
  PaveDroit(boolean s) { super(s,new Droit()); }
}

class PaveSignal extends Pave {
  PaveSignal(boolean s,int c) { super(s,new Cible(),new Feu(c),new Droit()); }

  void feu(int c) { Feu feu=(Feu)formes[1]; feu.c=c; }
  int getFeu() { return ((Feu)formes[1]).c; }
}

class PaveDroitN extends Pave {
  PaveDroitN(boolean s,int n) { super(s,new DroitN(n)); }
}

class PaveArc extends Pave {
  PaveArc(boolean s) { super(s,new Arc()); }
}

class PaveArcN extends Pave {
  PaveArcN(boolean s,int n) { super(s,new ArcN(n)); }
}

class PaveLettre extends Pave {
  PaveLettre(char c) { super(true,new Lettre(c)); }
}

class PaveNom extends Pave {
  PaveNom(String s) { super(true,new Nom(s)); }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class PaveBouton extends Pave {
  int no; // n° du bouton
  String nom; // nom sur le bouton
  boolean fond; // type de fond
  boolean cli=false; // pour clignotement
  
  PaveBouton(String s,int n,boolean b) { /*super(true,new Bouton(s,b));*/ no=n; nom=s; fond=b; }  // mettre 2 constructeurs ???
  
  void dessiner(int x,int y,int n) { 
    textSize(4*N); //    perturbe les lettres !!!
    textAlign(CENTER,CENTER); textMode(SHAPE);
    if (fond) fill(couleur); else fill(211,211,211); rect(B+x*9*N,B+y*9*N,9*N,9*N,3*N); 
    if (no==-2) fill(COULEUR_BLEUE); // bouton train bleu
    if (no==-1) fill(COULEUR_OR); // bouton fleche d'or
    else fill(color(0)); //noir
    text(nom,B+(x*9+4.5F)*N,B+(y*9+4.5F)*N);  
  }

  String nom() { return nom; } // obtention nom du bouton
  void couleur(int c,boolean x) { couleur=c; cli=x; } // coloration fond de bouton
  int no() { return no; } // obtention numero du bouton
  boolean cli() { return cli; }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////