/*
   for (Enumeration<E> e = v.elements(); e.hasMoreElements();)
       System.out.println(e.nextElement());
*/
import java.util.*;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Enum<T> implements Enumeration { // classe generique   T=Pave ou T=Point
  T[] elements; // tableau de T
  int no,nb; // position courante
  boolean sens;
  
  Enum(boolean s,T[] es,int n) { // constructeur
    elements=es; sens=s; nb=elements.length; if (sens) no=n-1; else no=n+1;
  } 
  
  Enum(boolean s,T[] es) { // constructeur
    elements=es; sens=s; nb=elements.length; if (sens) no=-1; else no=nb;
  } 
  
  boolean hasMoreElements() { if (sens) return no<nb-1; return no>0; } // test si encore des elements
  T nextElement() { if (sens) return elements[++no]; return elements[--no]; } // l'element courant
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class Train {
  Zone zone; // la zone ou est le train
  Pave pave; int x,y; // le pave et ses coordonnees
  Enum<Point> enumPoints; // pour enumeration des points
  Enum<Pave> enumPaves; // pour enumeration des paves
  boolean sens; // sens du train

  Point point;
  
  Train(boolean s,Zone z,int nPave,int nPoint) { 
    sens=s;
    zone=z; pave=zone.paves()[nPave]; x=pave.col; y=pave.lin; 
    enumPaves=new Enum(sens,zone.paves(),nPave+(sens?+1:-1)); // sens !!!
    point=pave.getPoints()[nPoint];
    enumPoints=new Enum(sens,pave.getPoints(),nPoint);
    portWrite(zone.no+'A'); // redondant !!!
  }
  
  //boolean sensImpair() { return true; }

  void inverser() { 
    if (!devantSignalFerme()) return; // que devant un signal ferme
    if (zone!=tco.z0 && zone!=tco.z1) return; // que dans z0 ou z1
    sens=!sens; enumPaves.sens=!enumPaves.sens; enumPoints.sens=!enumPoints.sens; 
  }
  
  boolean devantSignalFerme() { int c; // couleur du feu
    if ( pave instanceof PaveSignal && enumPoints.no==1) { // au milieu d'un pave signal
      c=((PaveSignal)pave).getFeu(); //println("feu  "+c);
      if (c==#FF0000 && pave.sens==sens) return true; // couleur rouge et bon sens
    }
    return false;
  }
  
  void avancer() { Zone copie; // copie de la zone
    if (devantSignalFerme()) return; // si signal ferme
    if (enumPoints.hasMoreElements()) { // encore des points
      point=enumPoints.nextElement(); return; 
    } // plus de points
    if (enumPaves.hasMoreElements()) { // encore des paves
      pave=enumPaves.nextElement(); x=pave.col; y=pave.lin;       
      enumPoints=new Enum(sens?pave.sens:!pave.sens,pave.getPoints()); avancer(); return; 
    } // plus de paves
    copie=zone;
    zone=zone.suivante(sens); // passer a la zone suivant
    portWrite(zone.no+'A'); // occuper la zone courante
    portWrite(copie.no+'a'); // liberer la zone precedente
    enumPaves=new Enum(sens,zone.paves()); avancer(); return; 
  }

  void dessiner(int c) {
    translate(B,B); // bordure
    scale(N); // zoom
    stroke(c); // couleur
    strokeWeight(3); // diametre
    point(x*9+point.x,y*9+point.y);
    strokeWeight(1);  
    resetMatrix();  
  }
}